diff --git a/src/backend/replication/logical/worker.c b/src/backend/replication/logical/worker.c
index 3d58910c14..7311ca75ab 100644
--- a/src/backend/replication/logical/worker.c
+++ b/src/backend/replication/logical/worker.c
@@ -1124,57 +1850,115 @@ apply_handle_prepare_internal(LogicalRepPreparedTxnData *prepare_data)
 
 /*
  * Handle PREPARE message.
+ *
+ * When time-delayed logical replication is requested, we just write a message
+ * into file and return. This means that no transaction is prepared on
+ * subscriber. This can avoid that the apply worker acquires locks for a long
+ * time due to the long min_apply_time.
+ *
+ * Even if the transaction is applied from delayed file, the transaction is not
+ * prepared. We just skip PREPARE message.
  */
 static void
 apply_handle_prepare(StringInfo s)
 {
 	LogicalRepPreparedTxnData prepare_data;
 
-	logicalrep_read_prepare(s, &prepare_data);
+	/*
+	 * If we are applying the delayed transaction, just consume the PREPARE
+	 * message and return.
+	 */
+	if (delayed_fd > 0 && !in_delayed_transaction)
+	{
+		/* Consume non-needed data */
+		(void) pq_getmsgint64(s);
+		(void) pq_getmsgint64(s);
+		(void) pq_getmsgint64(s);
+		(void) pq_getmsgint(s, 4);
 
-	if (prepare_data.prepare_lsn != remote_final_lsn)
-		ereport(ERROR,
-				(errcode(ERRCODE_PROTOCOL_VIOLATION),
-				 errmsg_internal("incorrect prepare LSN %X/%X in prepare message (expected %X/%X)",
-								 LSN_FORMAT_ARGS(prepare_data.prepare_lsn),
-								 LSN_FORMAT_ARGS(remote_final_lsn))));
+		return;
+	}
 
 	/*
-	 * Unlike commit, here, we always prepare the transaction even though no
-	 * change has happened in this transaction or all changes are skipped. It
-	 * is done this way because at commit prepared time, we won't know whether
-	 * we have skipped preparing a transaction because of those reasons.
-	 *
-	 * XXX, We can optimize such that at commit prepared time, we first check
-	 * whether we have prepared the transaction or not but that doesn't seem
-	 * worthwhile because such cases shouldn't be common.
+	 * If we are writing changes into delayed file, construct a modified
+	 * message and write it. This is needed for avoiding to write gid into
+	 * file. More detail, see atop ReadPreparedCommonRecord().
 	 */
-	begin_replication_step();
+	if (in_delayed_transaction)
+	{
+		/* Write the modifed message */
+		handle_delayed_prepared(LOGICAL_REP_MSG_PREPARE,
+								prepare_data.prepare_lsn,
+								prepare_data.end_lsn,
+								prepare_data.prepare_time,
+								prepare_data.xid);
+
+		/* Flush changes */
+		if (pg_fdatasync(delayed_fd) != 0)
+		{
+			int save_errno = errno;
+			close(delayed_fd);
+			errno = save_errno;
+			ereport(ERROR,
+					errcode_for_file_access(),
+					errmsg("could not fsync file"));
+		}
 
-	apply_handle_prepare_internal(&prepare_data);
+		/* Store flushed lsn */
+		last_flushed = prepare_data.end_lsn;
 
-	end_replication_step();
-	CommitTransactionCommand();
-	pgstat_report_stat(false);
+		/* Cleanup */
+		close(delayed_fd);
 
-	store_flush_position(prepare_data.end_lsn, XactLastCommitEnd);
+		delayed_fd = -1;
+		delayed_xid = InvalidTransactionId;
+		in_delayed_transaction = false;
+	}
+	else
+	{
+		logicalrep_read_prepare(s, &prepare_data);
 
-	in_remote_transaction = false;
+		if (prepare_data.prepare_lsn != remote_final_lsn)
+			ereport(ERROR,
+					(errcode(ERRCODE_PROTOCOL_VIOLATION),
+					errmsg_internal("incorrect prepare LSN %X/%X in prepare message (expected %X/%X)",
+									LSN_FORMAT_ARGS(prepare_data.prepare_lsn),
+									LSN_FORMAT_ARGS(remote_final_lsn))));
 
-	/* Process any tables that are being synchronized in parallel. */
-	process_syncing_tables(prepare_data.end_lsn);
+		/*
+		* Unlike commit, here, we always prepare the transaction even though no
+		* change has happened in this transaction or all changes are skipped. It
+		* is done this way because at commit prepared time, we won't know whether
+		* we have skipped preparing a transaction because of those reasons.
+		*
+		* XXX, We can optimize such that at commit prepared time, we first check
+		* whether we have prepared the transaction or not but that doesn't seem
+		* worthwhile because such cases shouldn't be common.
+		*/
+		begin_replication_step();
 
-	/*
-	 * Since we have already prepared the transaction, in a case where the
-	 * server crashes before clearing the subskiplsn, it will be left but the
-	 * transaction won't be resent. But that's okay because it's a rare case
-	 * and the subskiplsn will be cleared when finishing the next transaction.
-	 */
-	stop_skipping_changes();
-	clear_subscription_skip_lsn(prepare_data.prepare_lsn);
+		apply_handle_prepare_internal(&prepare_data);
 
-	pgstat_report_activity(STATE_IDLE, NULL);
-	reset_apply_error_context_info();
+		end_replication_step();
+		CommitTransactionCommand();
+		pgstat_report_stat(false);
+
+		store_flush_position(prepare_data.end_lsn, XactLastCommitEnd);
+
+		in_remote_transaction = false;
+
+		/* Process any tables that are being synchronized in parallel. */
+		process_syncing_tables(prepare_data.end_lsn);
+
+		/*
+		* Since we have already prepared the transaction, in a case where the
+		* server crashes before clearing the subskiplsn, it will be left but the
+		* transaction won't be resent. But that's okay because it's a rare case
+		* and the subskiplsn will be cleared when finishing the next transaction.
+		*/
+		stop_skipping_changes();
+		clear_subscription_skip_lsn(prepare_data.prepare_lsn);
+	}
 }
 
 /*
@@ -1192,38 +1976,95 @@ apply_handle_commit_prepared(StringInfo s)
 	LogicalRepCommitPreparedTxnData prepare_data;
 	char		gid[GIDSIZE];
 
-	logicalrep_read_commit_prepared(s, &prepare_data);
-	set_apply_error_context_xact(prepare_data.xid, prepare_data.commit_lsn);
-
-	/* Compute GID for two_phase transactions. */
-	TwoPhaseTransactionGid(MySubscription->oid, prepare_data.xid,
-						   gid, sizeof(gid));
+	if (delayed_fd > 0 && !in_delayed_transaction)
+		return;
 
-	/* There is no transaction when COMMIT PREPARED is called */
-	begin_replication_step();
+	logicalrep_read_commit_prepared(s, &prepare_data);
 
 	/*
-	 * Update origin state so we can restart streaming from correct position
-	 * in case of crash.
+	 * Check whether delayed file exists or not. If we have a file and we have
+	 * not opened yet, it means that time-delayed logical replication has been
+	 * requested. At that time we write the modified message.
+	 * Otherwise, the transaction will be committed normally.
 	 */
-	replorigin_session_origin_lsn = prepare_data.end_lsn;
-	replorigin_session_origin_timestamp = prepare_data.commit_time;
+	if (delayed_fd < 0 &&
+		is_given_transaction_delayed(MyLogicalRepWorker->subid, prepare_data.xid))
+	{
+		char		path[MAXPGPATH];
+		LogicalRepCommitData commit_data = {0};
 
-	FinishPreparedTransaction(gid, true);
-	end_replication_step();
-	CommitTransactionCommand();
-	pgstat_report_stat(false);
+		/* Open file again */
+		delay_file_name(path, MyLogicalRepWorker->subid, prepare_data.xid);
+		delayed_fd = BasicOpenFile(path, O_WRONLY | O_APPEND | PG_BINARY);
+		if (delayed_fd < 0)
+			ereport(ERROR,
+					errcode_for_file_access(),
+					errmsg("could not open file \"%s\": %m",
+						   path));
+
+		/* Write modified message to file */
+		handle_delayed_prepared(LOGICAL_REP_MSG_COMMIT_PREPARED,
+								prepare_data.commit_lsn,
+								prepare_data.end_lsn,
+								prepare_data.commit_time,
+								prepare_data.xid);
+		/* Flush it */
+		if (pg_fdatasync(delayed_fd) != 0)
+		{
+			int save_errno = errno;
+			close(delayed_fd);
+			errno = save_errno;
+			ereport(ERROR,
+					errcode_for_file_access(),
+					errmsg("could not fsync file"));
+		}
 
-	store_flush_position(prepare_data.end_lsn, XactLastCommitEnd);
-	in_remote_transaction = false;
+		/* Store flushed lsn */
+		last_flushed = prepare_data.end_lsn;
 
-	/* Process any tables that are being synchronized in parallel. */
-	process_syncing_tables(prepare_data.end_lsn);
+		/* clean up */
+		close(delayed_fd);
 
-	clear_subscription_skip_lsn(prepare_data.end_lsn);
+		delayed_fd = -1;
+		delayed_xid = InvalidTransactionId;
+		in_delayed_transaction = false;
 
-	pgstat_report_activity(STATE_IDLE, NULL);
-	reset_apply_error_context_info();
+		ConstructCommitFromCommitPrepared(&commit_data, &prepare_data);
+
+		/* Cache the commited transaction */
+		cache_commit_data(&commit_data, prepare_data.xid);
+	}
+	else
+	{
+		set_apply_error_context_xact(prepare_data.xid, prepare_data.commit_lsn);
+
+		/* Compute GID for two_phase transactions. */
+		TwoPhaseTransactionGid(MySubscription->oid, prepare_data.xid,
+							gid, sizeof(gid));
+
+		/* There is no transaction when COMMIT PREPARED is called */
+		begin_replication_step();
+
+		/*
+		* Update origin state so we can restart streaming from correct position
+		* in case of crash.
+		*/
+		replorigin_session_origin_lsn = prepare_data.end_lsn;
+		replorigin_session_origin_timestamp = prepare_data.commit_time;
+
+		FinishPreparedTransaction(gid, true);
+		end_replication_step();
+		CommitTransactionCommand();
+		pgstat_report_stat(false);
+
+		store_flush_position(prepare_data.end_lsn, XactLastCommitEnd);
+		in_remote_transaction = false;
+
+		/* Process any tables that are being synchronized in parallel. */
+		process_syncing_tables(prepare_data.end_lsn);
+
+		clear_subscription_skip_lsn(prepare_data.end_lsn);
+	}
 }
 
 /*
@@ -1242,6 +2083,20 @@ apply_handle_rollback_prepared(StringInfo s)
 	char		gid[GIDSIZE];
 
 	logicalrep_read_rollback_prepared(s, &rollback_data);
+
+	/*
+	 * If the delayed file exists, just remove it. The delayed transaction have
+	 * never prepared, so it's OK not to call FinishPreparedTransaction().
+	 */
+	if (is_given_transaction_delayed(MyLogicalRepWorker->subid, rollback_data.xid))
+	{
+		char path[MAXPGPATH];
+		delay_file_name(path, MyLogicalRepWorker->subid, rollback_data.xid);
+		durable_unlink(path, LOG);
+
+		return;
+	}
+
 	set_apply_error_context_xact(rollback_data.xid, rollback_data.rollback_end_lsn);
 
 	/* Compute GID for two_phase transactions. */
@@ -1317,16 +2172,68 @@ apply_handle_stream_prepare(StringInfo s)
 	switch (apply_action)
 	{
 		case TRANS_LEADER_APPLY:
+			/*
+			 * If time-delayed is requested, start to write changes to
+			 * permanent file instead of temporary one.
+			 */
+			if (MySubscription->minapplydelay)
+			{
+				in_delayed_transaction = true;
+
+				create_delay_file(prepare_data.xid);
+
+				delayed_xid = prepare_data.xid;
+			}
 
 			/*
 			 * The transaction has been serialized to file, so replay all the
 			 * spooled operations.
+			 * Note that if time-delayed replication is requested, changes are
+			 * written into permanent file here.
 			 */
 			apply_spooled_messages(MyLogicalRepWorker->stream_fileset,
 								   prepare_data.xid, prepare_data.prepare_lsn);
 
-			/* Mark the transaction as prepared. */
-			apply_handle_prepare_internal(&prepare_data);
+
+			/*
+			 * If time-delayed replication is requested, construct a modified
+			 * message and write it. This is needed for avoiding to write gid into
+			 * file. More detail, see atop ReadPreparedCommonRecord().
+			 */
+			if (MySubscription->minapplydelay)
+			{
+				/* Write the modified message */
+				handle_delayed_prepared(LOGICAL_REP_MSG_PREPARE,
+										prepare_data.prepare_lsn,
+										prepare_data.end_lsn,
+										prepare_data.prepare_time,
+										prepare_data.xid);
+
+				/* Flush changes */
+				if (pg_fdatasync(delayed_fd) != 0)
+				{
+					int save_errno = errno;
+					close(delayed_fd);
+					errno = save_errno;
+					ereport(ERROR,
+							errcode_for_file_access(),
+							errmsg("could not fsync file"));
+				}
+
+				/* Store flushed lsn */
+				last_flushed = prepare_data.end_lsn;
+
+				close(delayed_fd);
+
+				delayed_fd = -1;
+				delayed_xid = InvalidTransactionId;
+				in_delayed_transaction = false;
+			}
+			else
+			{
+				/* Mark the transaction as prepared. */
+				apply_handle_prepare_internal(&prepare_data);
+			}
 
 			CommitTransactionCommand();
 
@@ -1405,8 +2312,11 @@ apply_handle_stream_prepare(StringInfo s)
 
 	pgstat_report_stat(false);
 
-	/* Process any tables that are being synchronized in parallel. */
-	process_syncing_tables(prepare_data.end_lsn);
+	if (list_length(DelayedTxnList) == 0)
+	{
+		/* Process any tables that are being synchronized in parallel. */
+		process_syncing_tables(prepare_data.end_lsn);
+	}
 
 	/*
 	 * Similar to prepare case, the subskiplsn could be left in a case of
@@ -2175,19 +3085,43 @@ apply_handle_stream_commit(StringInfo s)
 	{
 		case TRANS_LEADER_APPLY:
 
+			/*
+			 * If time-delayed is requested, start to write changes to
+			 * permanent file instead of temporary one.
+			 */
+			if (MySubscription->minapplydelay)
+			{
+				in_delayed_transaction = true;
+
+				create_delay_file(xid);
+
+				delayed_xid = xid;
+			}
+
 			/*
 			 * The transaction has been serialized to file, so replay all the
 			 * spooled operations.
+			 * Note that if time-delayed replication is requested, changes are
+			 * written into permanent file here.
 			 */
 			apply_spooled_messages(MyLogicalRepWorker->stream_fileset, xid,
-								   commit_data.commit_lsn);
+									commit_data.commit_lsn);
 
-			apply_handle_commit_internal(&commit_data);
+
+			/* Flush changes if time-delayed is requested */
+			if (MySubscription->minapplydelay)
+			{
+				handle_delayed_transaction(LOGICAL_REP_MSG_COMMIT, &original_msg);
+				flush_delayed_changes(&commit_data);
+			}
+			else
+				apply_handle_commit_internal(&commit_data);
 
 			/* Unlink the files with serialized changes and subxact info. */
 			stream_cleanup_files(MyLogicalRepWorker->subid, xid);
 
 			elog(DEBUG1, "finished processing the STREAM COMMIT command");
+
 			break;
 
 		case TRANS_LEADER_SEND_TO_PARALLEL:
@@ -2249,8 +3183,11 @@ apply_handle_stream_commit(StringInfo s)
 			break;
 	}
 
-	/* Process any tables that are being synchronized in parallel. */
-	process_syncing_tables(commit_data.end_lsn);
+	if (list_length(DelayedTxnList) == 0)
+	{
+		/* Process any tables that are being synchronized in parallel. */
+		process_syncing_tables(commit_data.end_lsn);
+	}
 
 	pgstat_report_activity(STATE_IDLE, NULL);
 
@@ -2325,7 +3262,8 @@ apply_handle_relation(StringInfo s)
 {
 	LogicalRepRelation *rel;
 
-	if (handle_streamed_transaction(LOGICAL_REP_MSG_RELATION, s))
+	if (handle_streamed_transaction(LOGICAL_REP_MSG_RELATION, s) ||
+		handle_delayed_transaction(LOGICAL_REP_MSG_RELATION, s))
 		return;
 
 	rel = logicalrep_read_rel(s);
@@ -2348,7 +3286,8 @@ apply_handle_type(StringInfo s)
 {
 	LogicalRepTyp typ;
 
-	if (handle_streamed_transaction(LOGICAL_REP_MSG_TYPE, s))
+	if (handle_streamed_transaction(LOGICAL_REP_MSG_TYPE, s) ||
+		handle_delayed_transaction(LOGICAL_REP_MSG_TYPE, s))
 		return;
 
 	logicalrep_read_typ(s, &typ);
@@ -2408,7 +3347,8 @@ apply_handle_insert(StringInfo s)
 	 * streamed transactions.
 	 */
 	if (is_skipping_changes() ||
-		handle_streamed_transaction(LOGICAL_REP_MSG_INSERT, s))
+		handle_streamed_transaction(LOGICAL_REP_MSG_INSERT, s) ||
+		handle_delayed_transaction(LOGICAL_REP_MSG_INSERT, s))
 		return;
 
 	begin_replication_step();
@@ -2560,7 +3500,8 @@ apply_handle_update(StringInfo s)
 	 * streamed transactions.
 	 */
 	if (is_skipping_changes() ||
-		handle_streamed_transaction(LOGICAL_REP_MSG_UPDATE, s))
+		handle_streamed_transaction(LOGICAL_REP_MSG_UPDATE, s) ||
+		handle_delayed_transaction(LOGICAL_REP_MSG_UPDATE, s))
 		return;
 
 	begin_replication_step();
@@ -2741,7 +3682,8 @@ apply_handle_delete(StringInfo s)
 	 * streamed transactions.
 	 */
 	if (is_skipping_changes() ||
-		handle_streamed_transaction(LOGICAL_REP_MSG_DELETE, s))
+		handle_streamed_transaction(LOGICAL_REP_MSG_DELETE, s) ||
+		handle_delayed_transaction(LOGICAL_REP_MSG_DELETE, s))
 		return;
 
 	begin_replication_step();
@@ -3169,7 +4111,8 @@ apply_handle_truncate(StringInfo s)
 	 * streamed transactions.
 	 */
 	if (is_skipping_changes() ||
-		handle_streamed_transaction(LOGICAL_REP_MSG_TRUNCATE, s))
+		handle_streamed_transaction(LOGICAL_REP_MSG_TRUNCATE, s) ||
+		handle_delayed_transaction(LOGICAL_REP_MSG_TRUNCATE, s))
 		return;
 
 	begin_replication_step();
@@ -3436,6 +4379,10 @@ get_flush_position(XLogRecPtr *write, XLogRecPtr *flush,
 		}
 	}
 
+	/* If change are written into file, report the LSN instead */
+	if (last_flushed > *flush)
+		*flush = last_flushed;
+
 	*have_pending_txes = !dlist_is_empty(&lsn_mapping);
 }
 
@@ -3632,9 +4579,13 @@ LogicalRepApplyLoop(XLogRecPtr last_received)
 			maybe_reread_subscription();
 
 			/* Process any table synchronization changes. */
-			process_syncing_tables(last_received);
+			if (list_length(DelayedTxnList) == 0)
+				process_syncing_tables(last_received);
 		}
 
+		/* Check delayed transactions and apply them */
+		check_delayed_transaction();
+
 		/* Cleanup the memory. */
 		MemoryContextResetAndDeleteChildren(ApplyMessageContext);
 		MemoryContextSwitchTo(TopMemoryContext);
@@ -3776,8 +4727,14 @@ send_feedback(XLogRecPtr recvpos, bool force, bool requestReply)
 	/*
 	 * No outstanding transactions to flush, we can report the latest received
 	 * position. This is important for synchronous replication.
+	 *
+	 * If the logical replication subscription has unprocessed changes then do
+	 * not inform the publisher that the received latest LSN is already
+	 * applied and flushed, otherwise, the publisher will make a wrong
+	 * assumption about the logical replication progress. Instead, just send a
+	 * feedback message to avoid a replication timeout during the delay.
 	 */
-	if (!have_pending_txes)
+	if (!have_pending_txes && (list_length(DelayedTxnList) == 0))
 		flushpos = writepos = recvpos;
 
 	if (writepos < last_writepos)
@@ -4581,6 +5538,9 @@ ApplyWorkerMain(Datum main_arg)
 					(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
 					 errmsg("subscription has no replication slot set")));
 
+		/* Check delayed files or initialize directory */
+		InitializeDelayedTxn();
+
 		/* Setup replication origin tracking. */
 		StartTransactionCommand();
 		ReplicationOriginNameForLogicalRep(MySubscription->oid, InvalidOid,
diff --git a/src/bin/pg_dump/pg_dump.c b/src/bin/pg_dump/pg_dump.c
index 6abbcff683..2916965c56 100644
--- a/src/bin/pg_dump/pg_dump.c
+++ b/src/bin/pg_dump/pg_dump.c
@@ -4609,6 +4609,7 @@ getSubscriptions(Archive *fout)
 	int			i_subpublications;
 	int			i_subbinary;
 	int			i_subpasswordrequired;
+	int			i_subminapplydelay;
 	int			i,
 				ntups;
 
@@ -4663,11 +4664,13 @@ getSubscriptions(Archive *fout)
 	if (fout->remoteVersion >= 160000)
 		appendPQExpBufferStr(query,
 							 " s.suborigin,\n"
-							 " s.subpasswordrequired\n");
+							 " s.subpasswordrequired,\n"
+							 " s.subminapplydelay\n");
 	else
 		appendPQExpBuffer(query,
 						  " '%s' AS suborigin,\n"
-						  " 't' AS subpasswordrequired\n",
+						  " 't' AS subpasswordrequired,\n"
+						  " 0 AS subminapplydelay\n",
 						  LOGICALREP_ORIGIN_ANY);
 
 	appendPQExpBufferStr(query,
@@ -4697,6 +4700,7 @@ getSubscriptions(Archive *fout)
 	i_subdisableonerr = PQfnumber(res, "subdisableonerr");
 	i_suborigin = PQfnumber(res, "suborigin");
 	i_subpasswordrequired = PQfnumber(res, "subpasswordrequired");
+	i_subminapplydelay = PQfnumber(res, "subminapplydelay");
 
 	subinfo = pg_malloc(ntups * sizeof(SubscriptionInfo));
 
@@ -4729,6 +4733,8 @@ getSubscriptions(Archive *fout)
 		subinfo[i].suborigin = pg_strdup(PQgetvalue(res, i, i_suborigin));
 		subinfo[i].subpasswordrequired =
 			pg_strdup(PQgetvalue(res, i, i_subpasswordrequired));
+		subinfo[i].subminapplydelay =
+			atoi(PQgetvalue(res, i, i_subminapplydelay));
 
 		/* Decide whether we want to dump it */
 		selectDumpableObject(&(subinfo[i].dobj), fout);
@@ -4813,6 +4819,9 @@ dumpSubscription(Archive *fout, const SubscriptionInfo *subinfo)
 	if (strcmp(subinfo->subpasswordrequired, "t") != 0)
 		appendPQExpBuffer(query, ", password_required = false");
 
+	if (subinfo->subminapplydelay > 0)
+		appendPQExpBuffer(query, ", min_apply_delay = '%d ms'", subinfo->subminapplydelay);
+
 	appendPQExpBufferStr(query, ");\n");
 
 	if (subinfo->dobj.dump & DUMP_COMPONENT_DEFINITION)
diff --git a/src/bin/pg_dump/pg_dump.h b/src/bin/pg_dump/pg_dump.h
index ed6ce41ad7..6bf889a00a 100644
--- a/src/bin/pg_dump/pg_dump.h
+++ b/src/bin/pg_dump/pg_dump.h
@@ -662,6 +662,7 @@ typedef struct _SubscriptionInfo
 	char	   *subdisableonerr;
 	char	   *suborigin;
 	char	   *subsynccommit;
+	int			subminapplydelay;
 	char	   *subpublications;
 	char	   *subpasswordrequired;
 } SubscriptionInfo;
diff --git a/src/bin/psql/describe.c b/src/bin/psql/describe.c
index 83a37ee601..78f2426d99 100644
--- a/src/bin/psql/describe.c
+++ b/src/bin/psql/describe.c
@@ -6493,7 +6493,7 @@ describeSubscriptions(const char *pattern, bool verbose)
 	PGresult   *res;
 	printQueryOpt myopt = pset.popt;
 	static const bool translate_columns[] = {false, false, false, false,
-	false, false, false, false, false, false, false, false, false};
+	false, false, false, false, false, false, false, false, false, false};
 
 	if (pset.sversion < 100000)
 	{
@@ -6551,9 +6551,11 @@ describeSubscriptions(const char *pattern, bool verbose)
 		if (pset.sversion >= 160000)
 			appendPQExpBuffer(&buf,
 							  ", suborigin AS \"%s\"\n"
-							  ", subrunasowner AS \"%s\"\n",
+							  ", subrunasowner AS \"%s\"\n"
+							  ", subminapplydelay AS \"%s\"\n",
 							  gettext_noop("Origin"),
-							  gettext_noop("Run as Owner?"));
+							  gettext_noop("Run as Owner?"),
+							  gettext_noop("Min apply delay"));
 
 		appendPQExpBuffer(&buf,
 						  ",  subsynccommit AS \"%s\"\n"
diff --git a/src/bin/psql/tab-complete.c b/src/bin/psql/tab-complete.c
index e38a49e8bd..881f8288a7 100644
--- a/src/bin/psql/tab-complete.c
+++ b/src/bin/psql/tab-complete.c
@@ -1925,7 +1925,7 @@ psql_completion(const char *text, int start, int end)
 		COMPLETE_WITH("(", "PUBLICATION");
 	/* ALTER SUBSCRIPTION <name> SET ( */
 	else if (HeadMatches("ALTER", "SUBSCRIPTION", MatchAny) && TailMatches("SET", "("))
-		COMPLETE_WITH("binary", "disable_on_error", "origin", "slot_name",
+		COMPLETE_WITH("binary", "disable_on_error", "min_apply_delay", "origin", "slot_name",
 					  "streaming", "synchronous_commit");
 	/* ALTER SUBSCRIPTION <name> SKIP ( */
 	else if (HeadMatches("ALTER", "SUBSCRIPTION", MatchAny) && TailMatches("SKIP", "("))
@@ -3268,7 +3268,7 @@ psql_completion(const char *text, int start, int end)
 	/* Complete "CREATE SUBSCRIPTION <name> ...  WITH ( <opt>" */
 	else if (HeadMatches("CREATE", "SUBSCRIPTION") && TailMatches("WITH", "("))
 		COMPLETE_WITH("binary", "connect", "copy_data", "create_slot",
-					  "disable_on_error", "enabled", "origin", "slot_name",
+					  "disable_on_error", "enabled", "min_apply_delay", "origin", "slot_name",
 					  "streaming", "synchronous_commit", "two_phase");
 
 /* CREATE TRIGGER --- is allowed inside CREATE SCHEMA, so use TailMatches */
diff --git a/src/include/catalog/pg_subscription.h b/src/include/catalog/pg_subscription.h
index 91d729d62d..649e789240 100644
--- a/src/include/catalog/pg_subscription.h
+++ b/src/include/catalog/pg_subscription.h
@@ -74,6 +74,8 @@ CATALOG(pg_subscription,6100,SubscriptionRelationId) BKI_SHARED_RELATION BKI_ROW
 
 	Oid			subowner BKI_LOOKUP(pg_authid); /* Owner of the subscription */
 
+	int32		subminapplydelay;	/* Replication apply delay (ms) */
+
 	bool		subenabled;		/* True if the subscription is enabled (the
 								 * worker should be running) */
 
@@ -127,6 +129,7 @@ typedef struct Subscription
 								 * skipped */
 	char	   *name;			/* Name of the subscription */
 	Oid			owner;			/* Oid of the subscription owner */
+	int32		minapplydelay;	/* Replication apply delay (ms) */
 	bool		enabled;		/* Indicates if the subscription is enabled */
 	bool		binary;			/* Indicates if the subscription wants data in
 								 * binary format */
diff --git a/src/test/regress/sql/subscription.sql b/src/test/regress/sql/subscription.sql
index cc53458d91..d5ad91a96f 100644
--- a/src/test/regress/sql/subscription.sql
+++ b/src/test/regress/sql/subscription.sql
@@ -333,6 +333,31 @@ ALTER SUBSCRIPTION regress_testsub SET (slot_name = NONE);
 DROP SUBSCRIPTION regress_testsub;
 
 RESET SESSION AUTHORIZATION;
+
+-- fail -- min_apply_delay must be a non-negative integer
+CREATE SUBSCRIPTION regress_testsub CONNECTION 'dbname=regress_doesnotexist' PUBLICATION testpub WITH (connect = false, min_apply_delay = foo);
+CREATE SUBSCRIPTION regress_testsub CONNECTION 'dbname=regress_doesnotexist' PUBLICATION testpub WITH (connect = false, min_apply_delay = -1);
+
+-- fail - utilizing streaming = parallel with time-delayed replication is not supported
+CREATE SUBSCRIPTION regress_testsub CONNECTION 'dbname=regress_doesnotexist' PUBLICATION testpub WITH (connect = false, streaming = parallel, min_apply_delay = 123);
+
+-- success -- min_apply_delay value without unit is taken as milliseconds
+CREATE SUBSCRIPTION regress_testsub CONNECTION 'dbname=regress_doesnotexist' PUBLICATION testpub WITH (connect = false, min_apply_delay = 123);
+\dRs+
+
+-- success -- min_apply_delay value with unit is converted into ms and stored as an integer
+ALTER SUBSCRIPTION regress_testsub SET (min_apply_delay = '1 d');
+\dRs+
+
+-- fail - alter subscription with streaming = parallel should fail when time-delayed replication is set
+ALTER SUBSCRIPTION regress_testsub SET (streaming = parallel);
+
+-- fail - alter subscription with min_apply_delay should fail when streaming = parallel is set
+ALTER SUBSCRIPTION regress_testsub SET (min_apply_delay = 0, streaming = parallel);
+ALTER SUBSCRIPTION regress_testsub SET (min_apply_delay = 123);
+ALTER SUBSCRIPTION regress_testsub SET (slot_name = NONE);
+DROP SUBSCRIPTION regress_testsub;
+
 DROP ROLE regress_subscription_user;
 DROP ROLE regress_subscription_user2;
 DROP ROLE regress_subscription_user3;
diff --git a/src/test/subscription/t/001_rep_changes.pl b/src/test/subscription/t/001_rep_changes.pl
index 91aa068c95..01f2c4284d 100644
--- a/src/test/subscription/t/001_rep_changes.pl
+++ b/src/test/subscription/t/001_rep_changes.pl
@@ -515,6 +515,37 @@ $node_publisher->poll_query_until('postgres',
   or die
   "Timed out while waiting for apply to restart after renaming SUBSCRIPTION";
 
+# Test time-delayed logical replication
+#
+# If the subscription sets min_apply_delay parameter, the logical replication
+# worker will delay the transaction apply for min_apply_delay milliseconds. We
+# verify this by looking at the time difference between a) when tuples are
+# inserted on the publisher, and b) when those changes are replicated on the
+# subscriber. Even on slow machines, this strategy will give predictable behavior.
+
+# Set min_apply_delay parameter to 3 seconds
+my $delay = 3;
+$node_subscriber->safe_psql('postgres',
+	"ALTER SUBSCRIPTION tap_sub_renamed SET (min_apply_delay = '${delay}s')");
+
+# Before doing the insertion, get the current timestamp that will be
+# used as a comparison base.
+my $publisher_insert_time = time();
+$node_publisher->safe_psql('postgres',
+	"INSERT INTO tab_ins VALUES (generate_series(1101, 1120))");
+
+$node_subscriber->poll_query_until('postgres',
+	"SELECT count(*) = 1 FROM tab_ins WHERE a = 1120;"
+  )
+  or die
+  "failed to replicate changes";
+
+# This test is successful if and only if the LSN has been applied with at least
+# the configured apply delay.
+ok( time() - $publisher_insert_time >= $delay,
+	"subscriber applies WAL only after replication delay for non-streaming transaction"
+);
+
 # check all the cleanup
 $node_subscriber->safe_psql('postgres', "DROP SUBSCRIPTION tap_sub_renamed");
 
-- 
2.27.0

